#20140318

bl_info = { 
    "name": "MeshDeformer",
    "author": "imdjs",
    "version": (0, 1, 2),
    "blender": (2, 7, 0),
    "location": "View3D > Mesh Object > Properties >MeshDeformer",
    "description": "bind a seleted mesh to an active mesh ",
    "warning": "---",
    "wiki_url": "http://blog.sina.com.cn/u/1325600780",
    "tracker_url": "http://blog.sina.com.cn/s/blog_4f03100c01010wqb.html",
    "category": "Mesh"} 
    #category": "Add Mesh" "Object"  }
 
import os
from ctypes import*
import bpy  
from bpy.props import *
#////////////////////////////////////////////////////////////////////////////
b=False 
dir = os.path.dirname(__file__)
###print(dir)
dllpath32 = os.path.abspath("%s//blender32.dll" % dir)
dllpath64 = os.path.abspath("%s//blender64.dll" % dir)
dllpath32B ="B://blender32.dll" 
dllpath64B ="B://blender64.dll" 
#used_path = None
DLL=None

bpy.types.Scene.fp参数s2=FloatProperty(name="fp参数s2", description="--", default=0.5, min=0.0, max=1.0,
                                           soft_min=0.0, soft_max=1.0, step=3, precision=2)
try:
    if not DLL:
        try:
            DLL = CDLL(dllpath32);
        except:
            DLL = CDLL(dllpath64);
            #DLL = CDLL(dllpath64B)
            pass 

#////////////////////////////////////////////////////////////////////////////

    class 卐弹出窗口卐Operator(bpy.types.Operator):
        bl_idname = "o2.win"
        bl_label = "窗口"
        bl_options = {'REGISTER', 'UNDO'}
        
        sp=StringProperty(name="注意", description="", default="可能改变了点数或改了名字", );

        def draw(self, context):
            layout = self.layout;
            layout.prop(self, "sp");
            
        def invoke(self, context, event):#召唤  
            return context.window_manager.invoke_props_dialog(self,400,50);
        def execute(self, context):
            return {'FINISHED'};
          
#-------------------------------------------------------------------------------------
    class 卐记录与绑定网格卐Operator(bpy.types.Operator): 
        bl_idname = "o2.record"
        bl_label = "记录网格 "
        bl_description = "记录与绑定选定网格与激活网格(bind the seleted mesh to active mesh)"

        sp=StringProperty(name="注意", description="你确定要记录与绑定物体网格(are you sure want to bind)", default="are you sure want to bind？", );
  
        @classmethod 
        def poll(self,context):
            return (len(context.selected_editable_objects)==2 ) ;
            #return (oA and  oA.type=="MESH");

        def draw(self, context):
            layout = self.layout;
            layout.prop(self, "sp");
           
        def invoke(self, context, event):
            return context.window_manager.invoke_props_dialog(self);#把自身加入到dialog
            
        def execute(self,context):
            #print("execute",);
            s2=context.scene;
            oA=context.active_object;
            LoS=context.selected_objects
            oS=None;
            for o in LoS:
                if (o!=oA):
                    oS=o;
            #print ("oS=",oS.name,"   oA=",oA.name);
            cvpOA = c_void_p(oA.as_pointer());
            DLL.fΔΔ根据索引返回网点位置.restype= c_float;
            if(not oA):
                return ;
                #print("没有激活",);
            try:
                t=oA["f_oA"];
            except:
                oA["f_oA"]={};
            i网点数=DLL.iΔΔ返回网点数(cvpOA);
            
            Lf3位=[];
            for i点索引 in range(i网点数):#记录网点位置{"fVerts":[ [x,y,z],[x,y,z][x,y,z],... ]
                Lf3位.append([]);
                for i三步 in range(3):
                    Lf3位[i点索引].append(DLL.fΔΔ根据索引返回网点位置( i点索引,i三步,cvpOA));
                
            oA["f_oA"]["fVerts"]=Lf3位;
            #oA["f_oA"]["test"]=[[9.99,8.88,6.66,2.22]];
            oA["f_oA"]["test"]=[[9.99,8.88,6.66,2.22],[9.9,8.81,6,2.21]];#必须全部是浮点或整数
            #oA["f_oA"]["test"]=[[9,8,6,2],[99,88,66,22],[77,44,33,11]];

            oA["f_oA"]["num"]=i网点数;
            #----oS--------------------------------------------------------------------------
            cvpOS = c_void_p(oS.as_pointer());
            cvpOA = c_void_p(oA.as_pointer());
            i网点数=DLL.iΔΔ返回网点数(cvpOS);
            
            Li索f权=[];

            try:
                t=oS["f_oS"];
                #print("已经有f_oS",)
            except:
                oS["f_oS"]={};
                LLi=[[x for x in [-1.0,-1.0]] for y in range(s2.ip绑定点数s2)];
                #[[-1.0,-1.0],[-1.0,-1.0],[-1.0,-1.0],[-1.0,-1.0]]
                for i in range(i网点数):#增加空白属性
                    Li索f权.append(LLi);
                oS["f_oS"]["fWeight"]=Li索f权;
                #for i in range(i网点数):#增加空白属性 :
                    ##print(oS["f_oS"]["fWeight"][i][0][0]) #
            oS["oA"]=oA.as_pointer();#这个记录物体的指针地址 int
            oS["sA"]=oA.name;
            
            
            oA.sp激活的物点数o=str(oA["f_oA"]["num"]);
            oS["f_oS"]["num"]=i网点数;
            oS.sp激活的物点数o=str(oS["f_oS"]["num"]);
            oS.sp绑定的主物名o=oA.name;
            ##print ("Li索f权len＝=,i网点数＝=",len(Li索f权),i网点数);
            #----填充客点位-----------------------------------------------------------------------
            Lf3位=[];
            for i客索引 in range(i网点数):#记录网点位置{"fVerts":[ [x,y,z],[x,y,z][x,y,z],... ]
                Lf3位.append([]);#[[],[]]
                for i三步 in range(3):
                    Lf3位[i客索引].append(DLL.fΔΔ根据索引返回网点位置( i客索引,i三步,cvpOS));#[[x,y,z],[]]
            oS["f_oS"]["fVerts"]=Lf3位;


            oS["oA"]=oA.as_pointer();#记录的是指针int


            DLL.ΔΔ网点权重绑定(cvpOA,cvpOS,s2.ip绑定点数s2);
            #return bpy.ops.o2.win('INVOKE_DEFAULT',);#运行了卐弹出窗口卐Operator
            return {'FINISHED'};
#////////////////////////////////////////////////////////////////////////////      
    class 卐去除物属性卐Operator(bpy.types.Operator): 
        bl_idname = "o2.unbind"
        bl_label = "去绑定网格属性(unbind) "
        bl_description = "去绑定网格属性(unbind) "
        
        sp=StringProperty(name="注意", description="", default="你确定要删除记录的属性(unbind？)？" );
        
        @classmethod
        def poll(cls, context):
            oS = context.active_object          
            try:
                oS["f_oS"];
                return True ;
            except:
                return False ; #(obj and obj.type == 'MESH')
                
        def draw(self, context):
            layout = self.layout;
            layout.prop(self, "sp");
            
        def invoke(self, context, event):
            return context.window_manager.invoke_props_dialog(self);#把自身加入到dialog
            
        def execute(self,context):

            try:
                #oA=bpy.context.object;
                LoS=bpy.context.selected_objects;
                oS=None;
                for oS in LoS:      
                    oS.sp激活的物点数o="";
                    oS.sp绑定的主物名o="";
                    try:       
                        del  oS["f_oA"];
                        del oS["f_oS"];del oS["sA"];del oS["oA"];
                    except:
                        del oS["f_oS"];del oS["sA"];del oS["oA"];
                        del  oS["f_oA"];
                    
            except:
                pass;
            return {'FINISHED'};     
            
#------------------------------------------------------------------------------------       
    class 卐删除DLL卐Operator (bpy.types.Operator):
        '''删除dll'''
        bl_idname = 'de.dll';
        bl_label = '删除dll';
        bl_options = {'REGISTER', 'UNDO'};
        
        @classmethod
        def poll(cls, context):
            #obj = context.active_object          
            return True; #(obj and obj.type == 'MESH')
        def execute(self, context):
            if(DLL):
                ΔΔ删除属性();
                windll.kernel32.FreeLibrary(DLL._handle);#释放dll     
                bpy.utils.unregister_module(__name__);
                #bpy.types.VIEW3D_PT_view3d_meshdisplay.remove(ΔΔ面板);             
                #print ("已经删除DLL");
            ##print ("fp=",context.scene.fp参数s2)
            return {'FINISHED'};      
     
#///////////////////////////////////////////////////////////////////////////
    class 卐执行权重卐Operator (bpy.types.Operator):
        '''刷新选定网格'''
        bl_idname = 'exe.dll';
        bl_label = '刷新选定网格';
        bl_description = "刷新选定网格到激活网格(update the selected mesh to fit the binding mesh )"
        #bl_options = {'REGISTER', 'UNDO'};
        
        @classmethod
        def poll(cls, context):
            oS = context.active_object          
            try:
                oS["sA"];
                oS["f_oS"]
                return True ;
            except:
                return False ; #(obj and obj.type == 'MESH')
        def execute(self, context):      
            s2= context.scene ;     
            oS = context.active_object ;
            
            i激活客索引=oS.active_shape_key_index;
            if(not oS.active_shape_key):
                oS.shape_key_add(name="base", from_mix=True);
                oS.shape_key_add(name="key1", from_mix=True);
                i激活客索引=oS.active_shape_key_index=1;
            oS.active_shape_key.value=1;
            #print ("i激活客索引＝",i激活客索引)

                #cvpOA =oS["oA"];
                
            #except:  
            ##print ("except，没有oS[oA]");
            oA=bpy.data.objects[oS["sA"]];
            i激活主索引=oA.active_shape_key_index;
            if(not oA.active_shape_key):
                oA.shape_key_add(name="base", from_mix=True);
                oA.shape_key_add(name="key1", from_mix=True);
                i激活主索引=oA.active_shape_key_index=1;
            oA.active_shape_key.value=1;
            #cvpOA = c_void_p(oA.as_pointer());   
            #cvpOS = c_void_p(oS.as_pointer());
            
            #i网点数=DLL.iΔΔ返回网点数(cvpOS);            
            #DLL.ΔΔ执行权重(cvpOS);
            #oS.data.update();
            
            try:
                DLL.ΔΔ执行权重(oS.as_pointer(),i激活客索引,oA.as_pointer(),i激活主索引,s2.ip绑定点数s2);
                #DLL.ΔΔ执行权重(oS.as_pointer(),oA.as_pointer());
                oS.data.update();
                #oS["oA"].data.update();

            except:
                bpy.ops.de.dll('INVOKE_DEFAULT',);
                #bpy.ops.o2.win('INVOKE_DEFAULT',);

            return {'FINISHED'};


    #////////////////////////////////////////////////////////////////////////////
    def ΔΔ检测点数():
        oA = bpy.context.active_object;
        if(oA.sp激活的物点数o==""):
            return ;
        else:
            cvpOA = c_void_p(oA.as_pointer());
            b改变=DLL.ΔΔb网格点是否改变(cvpOA);
            if(b改变):
                #print("点数改变",);
                bpy.ops.o2.win('INVOKE_DEFAULT',);
#------------------------------------------------------------------------------------ 
    def ΔΔ面板(self, context):
        #self.layout.separator()
        oA = context.active_object;
        uil界= self.layout;
        uil界.separator();
        uil行=uil界.row(align=True);
        #col = self.layout.column(align=True)
        #uil行.active = (context.mode=="EDIT_MESH" );
        uil行.operator(卐记录与绑定网格卐Operator.bl_idname, text="",icon='LOCKED');
        uil行.prop(oA, 'sp激活的物点数o', icon_only=True ,emboss=False )#不能填写
        uil行.operator(卐去除物属性卐Operator.bl_idname, text="",icon='UNLOCKED');
        
        uil行=uil界.row(align=True);
        #uil行.operator(卐删除DLL卐Operator.bl_idname, text="反注册",);
        uil行.operator(卐绑定网格卐Operator.bl_idname, text="绑定选定物到激活物",);
        uil行.operator(卐执行权重卐Operator.bl_idname, text="刷新选定物",);
#///////////////////////////////////////////////////////////////////////////
    
    class 卐网格绑定卐Panel(bpy.types.Panel):
        bl_label ="MeshDeformer"    
        bl_space_type = 'VIEW_3D'
        bl_region_type = 'UI' 
        
        @classmethod 
        def poll(self,context):
            return True ;#context.mode == 'EDIT_MESH';
            
        def draw(self, context):
            oA = context.active_object;
            s2= context.scene ;
            uil界= self.layout;
            uil界.separator();
            uil行=uil界.row(align=True)#.split(0.3);
            #col = self.layout.column(align=True)
            #uil行.active = (context.mode=="EDIT_MESH" );
            #uil行.operator(卐记录与绑定网格卐Operator.bl_idname, text="",icon='LOCKED');
            try:
                uil行.prop(oA, 'sp激活的物点数o', icon_only=True ,emboss=False )#不能填写
                uil行.prop(oA, 'sp绑定的主物名o', icon_only=True ,emboss=False )#不能填写
            except:
                pass;
                
            #uil行.operator(卐去除物属性卐Operator.bl_idname, text="",icon='UNLOCKED');
            
            uil行=uil界.row(align=True);
            uil行.prop(s2, 'ip绑定点数s2', icon_only=False  ,emboss=True  )#能填写
            #uil行.operator(卐删除DLL卐Operator.bl_idname, text="反注册",); 
            uil行.operator(卐去除物属性卐Operator.bl_idname,  text="unbind",);
            uil行.operator(卐记录与绑定网格卐Operator.bl_idname,  text="bind",);
            uil行.operator(卐执行权重卐Operator.bl_idname, text="update",);
    #class 卐物体属性卐PropertyGroup(bpy.types.PropertyGroup):
        #ip物点数 = IntProperty(name="BEPUik Scene Address",description="---",default=0);
    #------------------------------------------------------------------------------------
    
    def ΔΔ检测物点数(self, context):#必须有self, context
        if(oA["f_oA"]==-1):
            return ;
        oA=bpy.context.object;
        if(oA):
            #print("有oA",);
            oA.sp激活的物点数o=str(oA["f_oA"]["num"]);
        else:
            pass;
            #print("无oA",);
    def ΔΔ建立属性():
        #bpy.types.Object.ip物点数o =IntProperty(name="点数",default=0);
        bpy.types.Object.sp激活的物点数o = StringProperty(name='NUM',default="");#update=ΔΔ检测物点数
        bpy.types.Object.sp绑定的主物名o = StringProperty(name='master',default="");
        bpy.types.Scene.ip绑定点数s2=IntProperty(name='', description="points to define the bind weight (用多少个点来决定权重)", default=5);
        #bpy.types.PoseBone.pp = PointerProperty(type=卐骨骼属性卐PropertyGroup);
    def ΔΔ删除属性():   
        del bpy.types.Object.sp激活的物点数o;
        del bpy.types.Object.sp绑定的主物名o;
        del bpy.types.Scene.ip绑定点数s2;
        try:
            LoS=bpy.context.selected_objects;
            oS=None;
            for oS in LoS:      
                try:       
                    del  oS["f_oA"]
                    #print ("成功ΔΔ删除属性oS")#del oS["sA"];del oS["oA"];
                except:
                    del oS["f_oS"];#del oS["sA"];del oS["oA"];
                    #print ("成功ΔΔ删除属性oA")
                    pass;
            #print ("成功ΔΔ删除属性()")
        except:
            pass;
        return {'FINISHED'};  
    
    #///////////////////////////////////////////////////////////////////////////
    def register(): 
        bpy.utils.register_module(__name__);
        ΔΔ建立属性();
        #bpy.types.VIEW3D_PT_view3d_meshdisplay.append(ΔΔ面板);#网格显示面板
        
    def unregister():
        bpy.utils.unregister_module(__name__);
        ΔΔ删除属性();
        #bpy.types.VIEW3D_PT_view3d_meshdisplay.remove(ΔΔ面板);
        
    if __name__ == "__main__":
        register();
        
    b=True ;
    
#////////////////////////////////////////////////////////////////////////////
except: 
    #print("异常",);
    windll.kernel32.FreeLibrary(DLL._handle)#
finally:   

    if(b==False  and DLL):
       windll.kernel32.FreeLibrary(DLL._handle)#
       #print("自动删除DLL",);
    
    